import { Component, Directive, ElementRef, Renderer2, ChangeDetectionStrategy, ViewEncapsulation } from '@angular/core';
import { ConfigurationService } from './utils/configuration/configuration.service';
import {Observable}       from 'rxjs';
import { EnvProperties } from './utils/properties/env-properties';
import {ActivatedRoute} from '@angular/router';
import{EnvironmentSpecificService} from './utils/properties/environment-specific.service';
import{MenuItem,RootMenuItem} from './sharedComponents/menu';

@Component({
  //changeDetection: ChangeDetectionStrategy.Default,
  //encapsulation: ViewEncapsulation.Emulated,
  selector: 'app-root',
  styles: [`
  `],
  template: `

        <navbar *ngIf= "properties" portal="explore" [properties]=properties [onlyTop]=false [userMenu]=true [communityId]="properties.adminToolsCommunity"  [userMenuItems]=userMenuItems [menuItems]=menuItems ></navbar>
        <h1>Openaire Lib Component</h1>


          <!--div id="tm-main" class=" uk-section  uk-margin-large-top tm-middle custom-main-content"   >
                <div uk-grid uk-grid>
                   <div class="tm-main uk-width-1-1@s uk-width-1-1@m  uk-width-1-1@l uk-row-first "-->
                   <div class="custom-main-content"   >
                      <main>
                       <router-outlet></router-outlet>

                     </main>
                    </div>
                   <!--/div>


                </div>
          </div-->
          <!--feedback *ngIf= "isClient"></feedback-->
          <cookie-law *ngIf= "isClient" position="bottom">
              OpenAIRE uses cookies in order to function properly.<br>
              Cookies are small pieces of data that websites store in your browser to allow us to give you the best browsing experience possible.
              By using the OpenAIRE portal you accept our use of cookies. <a href="http://ec.europa.eu/ipg/basics/legal/cookies/index_en.htm" target="_blank"> Read more <span class="uk-icon">
              <svg width="20" height="20" viewBox="0 0 20 20" xmlns="http://www.w3.org/2000/svg" icon="chevron-right" ratio="1"><polyline fill="none" stroke="#000" stroke-width="1.03" points="7 4 13 10 7 16"></polyline></svg>
              </span></a>
          </cookie-law>
           <bottom *ngIf= "isClient && properties"  [assetsPath]=assetsPath [properties]=properties></bottom>

`

})
export class AppComponent {
   isClient:boolean = false;
     public properties:EnvProperties = null;

   constructor(private config: ConfigurationService, private  route: ActivatedRoute, private propertiesService:EnvironmentSpecificService) {
   }

   assetsPath = "assets/";
   userMenuItems:MenuItem[] =  [ new MenuItem("","My profile","","",false,[],[],{}),
   new MenuItem("","My claims","","/myclaims",false,[],["/myclaims"],{}),
   new MenuItem("","Manage all claims","","/claims",true,[],["/claims"],{})]


   menuItems:RootMenuItem [] = [
     {rootItem: new MenuItem("search","Search","","/search/find",false,[],["/search/find"],{}),
       items: [new MenuItem("","Publications","","/search/find/publications",false,["publication"],["/search/find/publications"],{}),
       new MenuItem("","Research Data","","/search/find/datasets",false,["dataset"],["/search/find/datasets"],{}),
       new MenuItem("","Software","","/search/find/software",false,["software"],["/search/find/software"],{}),
       new MenuItem("","Other Research Products","","/search/find/other",false,["orp"],["/search/find/other"],{}),
       new MenuItem("","Projects","","/search/find/projects/",false,["project"],["/search/find/projects"],{}),
       new MenuItem("","Content Providers","","/search/find/dataproviders",false,["datasource"],["/search/find/dataproviders"],{}),
       new MenuItem("","Organizations","","/search/find/organizations/",false,["organization"],["/search/find/organizations"],{})
     ]},
     {
     rootItem: new MenuItem("share","Share","","",false,[],["/participate/deposit-publications","/participate/deposit-datasets"],{}),
     items: [new MenuItem("","Publications","","/participate/deposit-publications",false,["publication"],["/participate/deposit-publications"],{}),
     new MenuItem("","Research Data","","/participate/deposit-datasets",false,["dataset"],["/participate/deposit-datasets"],{})]
     },
     {
     rootItem: new MenuItem("link","Link","","/participate/claim",false,[],["/participate/claim"],{}),
     items: []
     },
     {
     rootItem: new MenuItem("datasources","Content Providers","","",false,["datasource"],[],{}),
     items: [new MenuItem("","Data Policies","https://beta.openaire.eu/oa-policies-mandates","",false,["datasource"],[],{}),
     new MenuItem("","Repositories","","/search/content-providers",false,["datasource"],["/search/content-providers"],{}),
     new MenuItem("","Journals","","/search/journals",false,["datasource"],["/search/journals"],{}),
     new MenuItem("","Registries","","/search/entity-registries",false,["datasource"],["/search/entity-registries"],{}),
     new MenuItem("","Browse all","","/search/find/dataproviders",false,["datasource"],["/search/find/dataproviders"],{})]
     }
 ];
   ngOnInit() {

     this.propertiesService.loadEnvironment()
             .then(es => {
                 this.propertiesService.setEnvProperties(es);
                 this.properties = this.propertiesService.envSpecific;
             }, error => {
               console.log("App couldn't fetch properties");
                 console.log(error);

             });
     if (typeof document !== 'undefined') {
       try{
         this.isClient = true;
       }catch (e) {
       }
     }
   }



}
