import { NgModule } from '@angular/core';
import {RouterModule} from '@angular/router';
import {CommonModule} from '@angular/common';
import {FormsModule, ReactiveFormsModule} from '@angular/forms';
import {AlertModalModule} from '../../utils/modal/alertModal.module';
import {DivIdsComponent} from './divIds.component';
import {DivIdsRoutingModule} from './divIds-routing.module';
import {AdminLoginGuard} from "../../login/adminLoginGuard.guard";
import {AdminToolServiceModule} from "../../services/adminToolService.module";
import {InputModule} from "../../../library/sharedComponents/input/input.module";


import {MatAutocompleteModule} from '@angular/material/autocomplete';
import {MatCheckboxModule, MatFormFieldModule} from "@angular/material";


import {MatChipsModule} from '@angular/material/chips';
@NgModule({
    imports: [
        CommonModule,  RouterModule, FormsModule,
        AlertModalModule, ReactiveFormsModule, DivIdsRoutingModule, AdminToolServiceModule, InputModule, MatAutocompleteModule, MatFormFieldModule, MatChipsModule,
        MatCheckboxModule
    ],
    declarations: [DivIdsComponent],
    providers: [AdminLoginGuard],
    exports: [DivIdsComponent]
})
export class DivIdsModule { }
