import { NgModule } from '@angular/core';
import {RouterModule} from '@angular/router';
import {CommonModule} from '@angular/common';
import {EntitiesComponent} from './entities.component';
import {FormsModule, ReactiveFormsModule} from '@angular/forms';
import {AlertModalModule} from '../../utils/modal/alertModal.module';
import {EntitiesRoutingModule} from './entities-routing.module';
import {MatSlideToggleModule} from '@angular/material';
import {IsCommunityOrAdmin} from '../../connect/communityGuard/isCommunityOrAdmin';
import {AdminToolServiceModule} from "../../services/adminToolService.module";
import {InputModule} from "../../../library/sharedComponents/input/input.module";

@NgModule({
  imports: [
    CommonModule, RouterModule, FormsModule, AdminToolServiceModule,
    AlertModalModule, ReactiveFormsModule, EntitiesRoutingModule, MatSlideToggleModule, InputModule
  ],
    declarations: [EntitiesComponent],
    providers: [IsCommunityOrAdmin],
    exports: [EntitiesComponent]
})
export class EntitiesModule { }
