import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import {CommunitiesComponent} from './communities.component';
import {CommunitiesRoutingModule} from './communities-routing.module';
import {RouterModule} from '@angular/router';
import {FormsModule, ReactiveFormsModule} from '@angular/forms';
import {AlertModalModule} from '../../utils/modal/alertModal.module';
import {AdminLoginGuard} from '../../login/adminLoginGuard.guard';
import {AdminToolServiceModule} from "../../services/adminToolService.module";
import {InputModule} from "../../../library/sharedComponents/input/input.module";

@NgModule({
  imports: [
    CommonModule, FormsModule, AlertModalModule,
    ReactiveFormsModule,
    CommunitiesRoutingModule, RouterModule, AdminToolServiceModule, InputModule
  ],
  declarations: [CommunitiesComponent],
  providers: [AdminLoginGuard],
  exports: [CommunitiesComponent]
})
export class CommunitiesModule { }
