import { NgModule }            from '@angular/core';
import { CommonModule }        from '@angular/common';
import { FormsModule }         from '@angular/forms';

import { DepositBySubjectResultComponent } from './depositBySubjectResult.component';

import {DepositModule} from '../deposit.module';
import {FreeGuard} from'../../login/freeGuard.guard';
import {PreviousRouteRecorder} from '../../utils/piwik/previousRouteRecorder.guard';
import {PagingModule } from '../../utils/paging.module';
import {DataProvidersServiceModule} from '../../services/dataProvidersService.module';
import {SearchResultsModule } from '../../searchPages/searchUtils/searchResults.module';
import {HelperModule} from '../../utils/helper/helper.module';
import {IsRouteEnabled} from '../../error/isRouteEnabled.guard';
import {Schema2jsonldModule} from '../../sharedComponents/schema2jsonld/schema2jsonld.module';
import { SEOServiceModule } from '../../sharedComponents/SEO/SEOService.module';

@NgModule({
  imports: [
    CommonModule, FormsModule,
    DepositModule,
    SearchResultsModule, DataProvidersServiceModule, PagingModule,
    HelperModule, Schema2jsonldModule, SEOServiceModule
  ],
  declarations: [

    DepositBySubjectResultComponent

  ],
  exports: [
    DepositBySubjectResultComponent
   ],
  providers:    [FreeGuard,PreviousRouteRecorder, IsRouteEnabled]
})
export class DepositBySubjectResultsModule { }
