import {Component, Input} from '@angular/core';
import {ActivatedRoute}   from '@angular/router';
import {EnvProperties}    from '../../utils/properties/env-properties';
import {ZenodoInformationClass} from '../utils/zenodoInformation.class';

@Component({
    selector: 'deposit-datasets',
    template: `
    <div id="tm-main" class=" uk-section uk-padding-remove-top tm-middle"   >
      <div uk-grid uk-grid>
       <div class="tm-main uk-width-1-1@s uk-width-1-1@m  uk-width-1-1@l uk-row-first ">

    <div class="uk-container">
        <deposit  [compatibility]="'openaire____::21f8a223b9925c2f87c404096080b046||Registry of Research Data Repository'"
                  [requestFor]="'Research Data'" [searchBySubjects]=true [piwikSiteId]=piwikSiteId
                  [zenodoInformation]="zenodoInformation">
        </deposit>
    <div>
    </div>
  </div>
</div>
    `
})

export class DepositDatasetsComponent {
  @Input() piwikSiteId = null;
  properties:EnvProperties;
  @Input() zenodoInformation: ZenodoInformationClass;

  constructor (private route: ActivatedRoute) {}

  ngOnInit() {
    this.route.data
      .subscribe((data: { envSpecific: EnvProperties }) => {
         this.properties = data.envSpecific;

         if(!this.zenodoInformation) {
           this.zenodoInformation = new ZenodoInformationClass();
         }
         if(!this.zenodoInformation.url) {
           this.zenodoInformation.url = this.properties.zenodo;
         }
         if(!this.zenodoInformation.name) {
           this.zenodoInformation.name = "Zenodo";
         }
      });
  }
}
