import { NgModule }            from '@angular/core';
import { CommonModule }        from '@angular/common';
import { FormsModule }         from '@angular/forms';

import { DepositDatasetsResultComponent } from './depositDatasetsResult.component';

import {DepositModule} from '../deposit.module';
import {FreeGuard} from'../../login/freeGuard.guard';
import {PreviousRouteRecorder} from '../../utils/piwik/previousRouteRecorder.guard';
import {IsRouteEnabled} from '../../error/isRouteEnabled.guard';

@NgModule({
  imports: [
    CommonModule, FormsModule,
    DepositModule
  ],
  declarations: [

    DepositDatasetsResultComponent,

  ],
  exports: [
    DepositDatasetsResultComponent,
   ],
  providers:    [FreeGuard,PreviousRouteRecorder, IsRouteEnabled]
})
export class DepositDatasetsResultsModule { }
