/* Common Component of deposit for both research data & ppublications*/

import { NgModule }            from '@angular/core';
import { CommonModule }        from '@angular/common';
import { FormsModule }         from '@angular/forms';
import { RouterModule } from '@angular/router';

import { DepositComponent } from './deposit.component';
import { DepositResultComponent } from './depositResult.component';
import {EntitiesAutocompleteModule} from '../utils/entitiesAutoComplete/entitiesAutoComplete.module';
import {DataProvidersServiceModule} from '../services/dataProvidersService.module';
import {OrganizationServiceModule} from '../services/organizationService.module';
import {SearchResultsModule } from '../searchPages/searchUtils/searchResults.module';
import {PiwikServiceModule} from '../utils/piwik/piwikService.module';
import {HelperModule} from '../utils/helper/helper.module';
import { DepositBySubjectComponent } from './datasets/depositBySubject.component';
import {IFrameModule} from '../utils/iframe.module';
import {Schema2jsonldModule} from '../sharedComponents/schema2jsonld/schema2jsonld.module';
import { SEOServiceModule } from '../sharedComponents/SEO/SEOService.module';
import{SearchPagingModule} from '../searchPages/searchUtils/searchPaging.module';
import {ApprovedByCommunityModule} from '../connect/approvedByCommunity/approved.module';


 @NgModule({
  imports: [
    CommonModule, FormsModule,
    RouterModule,
    EntitiesAutocompleteModule,
    DataProvidersServiceModule,
    OrganizationServiceModule,
    SearchResultsModule,
    PiwikServiceModule,
    HelperModule,
    IFrameModule, Schema2jsonldModule, SEOServiceModule,
    SearchPagingModule, ApprovedByCommunityModule
  ],
  declarations: [
    DepositComponent,
    DepositResultComponent,
    DepositBySubjectComponent
  ],
  exports: [
    DepositComponent,
    DepositResultComponent
  ],
  providers:    [
  ]
})
export class DepositModule { }
