import { NgModule}            from '@angular/core';
import { CommonModule }        from '@angular/common';
import { FormsModule }         from '@angular/forms';
import { RouterModule } from '@angular/router';

import{SearchDataprovidersToDepositComponent} from './searchDataprovidersToDeposit.component';

import {SearchResultsModule } from '../searchPages/searchUtils/searchResults.module';

import {DataProvidersServiceModule} from '../services/dataProvidersService.module';
import {SearchFormModule} from  '../searchPages/searchUtils/searchForm.module';
import {SearchPageModule} from '../searchPages/searchUtils/searchPage.module';
import {FreeGuard} from'../login/freeGuard.guard';
import {IsRouteEnabled} from '../error/isRouteEnabled.guard';

@NgModule({
  imports: [
    CommonModule, FormsModule,
    RouterModule,
    DataProvidersServiceModule,
    SearchFormModule, SearchResultsModule, SearchPageModule

  ],
  declarations: [
    SearchDataprovidersToDepositComponent
  ],
  providers:[FreeGuard, IsRouteEnabled],
  exports: [
    SearchDataprovidersToDepositComponent
  ]
})
export class SearchDataprovidersToDepositModule { }
