/* This module contains all common components for all landing pages */

import { NgModule}            from '@angular/core';
import { CommonModule }        from '@angular/common';
import { FormsModule }         from '@angular/forms';
import { RouterModule }       from '@angular/router';

import { ProjectsServiceModule} from '../../services/projectsService.module';
import { TabResultModule } from '../../searchPages/searchUtils/tabResult.module';
import { SearchingProjectsTabComponent} from './searchingProjectsInTab.component';

import {PagingModule } from '../../utils/paging.module';
import {ErrorMessagesModule} from '../../utils/errorMessages.module';

@NgModule({
  imports: [
      RouterModule, CommonModule, FormsModule,
      ProjectsServiceModule, TabResultModule,
      PagingModule, ErrorMessagesModule
   ],
  declarations: [
     SearchingProjectsTabComponent
  ],
  providers:[
   ],
  exports: [

    SearchingProjectsTabComponent
    ]
})
export class SearchingProjectsTabModule { }
