import {NgModule} from '@angular/core';
import {CommonModule} from '@angular/common';
import {FormsModule} from '@angular/forms';
import {RouterModule} from '@angular/router';

import {LoadingModalModule} from '../../utils/modal/loadingModal.module';
import {AlertModalModule} from '../../utils/modal/alertModal.module';
import {ErrorMessagesModule} from '../../utils/errorMessages.module';

import {OrganizationServiceModule} from '../../services/organizationService.module';
import {OrganizationComponent} from './organization.component';
import {LandingModule} from '../landing-utils/landing.module';
import {TabResultModule} from '../../searchPages/searchUtils/tabResult.module';
import {DataProvidersServiceModule} from '../../services/dataProvidersService.module';
import {ReportsServiceModule} from '../../services/reportsService.module';
import {SearchResearchResultsServiceModule} from '../../services/searchResearchResultsService.module';
import {ProjectsServiceModule} from '../../services/projectsService.module';

import {SearchingProjectsTabModule} from '../landing-utils/searchingProjectsInTab.module';
import {FreeGuard} from '../../login/freeGuard.guard';
import {IsRouteEnabled} from '../../error/isRouteEnabled.guard';
import {Schema2jsonldModule} from '../../sharedComponents/schema2jsonld/schema2jsonld.module';
import {SEOServiceModule} from '../../sharedComponents/SEO/SEOService.module';
import {HelperModule} from "../../utils/helper/helper.module";
import {OrganizationsDeletedByInferenceModule} from "./deletedByInference/deletedByInference.module";


@NgModule({
  imports: [
    CommonModule, FormsModule, RouterModule,
    LoadingModalModule, AlertModalModule, ErrorMessagesModule,
    LandingModule,
    TabResultModule,
    DataProvidersServiceModule,
    ReportsServiceModule,
    OrganizationServiceModule,
    SearchingProjectsTabModule,
    OrganizationServiceModule,
    SearchResearchResultsServiceModule,
    ProjectsServiceModule,
    Schema2jsonldModule, SEOServiceModule, HelperModule,
    OrganizationsDeletedByInferenceModule
  ],
  declarations: [
    OrganizationComponent,
  ],
  providers: [
    FreeGuard, IsRouteEnabled
  ],
  exports: [
    OrganizationComponent
  ]
})
export class OrganizationModule {
}
