//import {MaterialModule} from '@angular/material';
import { NgModule}            from '@angular/core';
import { CommonModule }       from '@angular/common';
import { FormsModule }        from '@angular/forms';
import { RouterModule }       from '@angular/router';

import { ProjectServiceModule} from './projectService.module';
import {LoadingModalModule} from '../../utils/modal/loadingModal.module';
import {AlertModalModule} from '../../utils/modal/alertModal.module';
import {ErrorMessagesModule} from '../../utils/errorMessages.module';

import { ProjectComponent } from './project.component';
import {IFrameModule} from '../../utils/iframe.module';
import {MetricsModule} from '../landing-utils/metrics.module';
import {ReportsServiceModule} from '../../services/reportsService.module';
import {SearchResearchResultsServiceModule} from '../../services/searchResearchResultsService.module';
import {TabResultModule } from '../../searchPages/searchUtils/tabResult.module';
import { LandingModule } from '../landing-utils/landing.module';
import {FreeGuard} from'../../login/freeGuard.guard';
import {IsRouteEnabled} from '../../error/isRouteEnabled.guard';
import {Schema2jsonldModule} from '../../sharedComponents/schema2jsonld/schema2jsonld.module';
import { SEOServiceModule } from '../../sharedComponents/SEO/SEOService.module';
import {HelperModule} from "../../utils/helper/helper.module";

@NgModule({
  imports: [
    CommonModule, FormsModule, RouterModule, LandingModule,
    LoadingModalModule, AlertModalModule, ErrorMessagesModule,
    TabResultModule, IFrameModule, MetricsModule, ReportsServiceModule,
    SearchResearchResultsServiceModule, ProjectServiceModule,
    Schema2jsonldModule, SEOServiceModule, HelperModule

  ],
  declarations: [
    ProjectComponent
  ],
  providers:[
    FreeGuard, IsRouteEnabled
  ],
  exports: [
    ProjectComponent
  ]
})
export class ProjectModule { }
