import {NgModule}                     from '@angular/core';
import {CommonModule}                 from '@angular/common';
import {FormsModule}                  from '@angular/forms';
import {RouterModule}                 from '@angular/router';

import {SharedModule}                 from '../../shared/shared.module';
import {MetricsModule}                from '../landing-utils/metrics.module';
import {LandingModule}                from '../landing-utils/landing.module';
import {CiteThisModule}               from '../landing-utils/citeThis/citeThis.module';
import {IFrameModule}                 from '../../utils/iframe.module';
import {AltMetricsModule}             from '../../utils/altmetrics.module';
import {PagingModule}                 from '../../utils/paging.module';
import {ConfigurationServiceModule}   from '../../utils/configuration/configurationService.module';

import {FreeGuard}                    from '../../login/freeGuard.guard';
import {IsRouteEnabled}               from '../../error/isRouteEnabled.guard';
import {ResultLandingService}         from './resultLanding.service';
import {ResultLandingComponent}       from './resultLanding.component';
import {Schema2jsonldModule}          from '../../sharedComponents/schema2jsonld/schema2jsonld.module';
import { SEOServiceModule }           from '../../sharedComponents/SEO/SEOService.module';

import {DeletedByInferenceModule}     from './deletedByInference/deletedByInference.module';
import {ShowAuthorsModule}            from "../../utils/authors/showAuthors.module";
import {HelperModule}                 from "../../utils/helper/helper.module";
import {ResultLandingUtilsModule}     from "../landing-utils/resultLandingUtils.module";
import {AlertModalModule}             from "../../utils/modal/alertModal.module";

@NgModule({
  imports: [
    CommonModule, FormsModule, LandingModule, SharedModule, RouterModule,
    CiteThisModule, PagingModule, IFrameModule,
    MetricsModule, AltMetricsModule, ConfigurationServiceModule, Schema2jsonldModule, SEOServiceModule,
    DeletedByInferenceModule, ShowAuthorsModule, HelperModule, ResultLandingUtilsModule, AlertModalModule
  ],
  declarations: [
    ResultLandingComponent
  ],
  providers: [
    ResultLandingService, FreeGuard, IsRouteEnabled
  ],
  exports: [
    ResultLandingComponent
  ]
})
export class ResultLandingModule { }
