import {NgModule}              from '@angular/core';
import {CommonModule}          from '@angular/common';
import {FormsModule}           from '@angular/forms';
import { RouterModule } from '@angular/router';

import {UserRoutingModule}     from './user-routing.module';

import {UserComponent}         from './user.component';

import {PreviousRouteRecorder} from '../utils/piwik/previousRouteRecorder.guard';
import {FreeGuard}             from './freeGuard.guard';
import {LoginGuard}            from './loginGuard.guard';

@NgModule({
  imports: [
    CommonModule, FormsModule, UserRoutingModule, RouterModule
  ],
  providers: [
    PreviousRouteRecorder, FreeGuard, LoginGuard
  ],
  declarations: [
    UserComponent
  ],
  exports: [
    UserComponent
  ]
})

export class UserModule { }
