import { NgModule}            from '@angular/core';
import { CommonModule }        from '@angular/common';
import { FormsModule }         from '@angular/forms';

import {AdvancedSearchResearchResultsComponent} from './advancedSearchResearchResults.component';

import {SearchResearchResultsServiceModule} from '../../services/searchResearchResultsService.module';
import {AdvancedSearchPageModule} from '../searchUtils/advancedSearchPage.module';
import {FreeGuard} from'../../login/freeGuard.guard';
import {IsRouteEnabled} from '../../error/isRouteEnabled.guard';

@NgModule({
  imports: [
    CommonModule, FormsModule,
    SearchResearchResultsServiceModule,
    AdvancedSearchPageModule

  ],
  declarations: [
    AdvancedSearchResearchResultsComponent
  ],
  providers:[FreeGuard, IsRouteEnabled],
  exports: [
    AdvancedSearchResearchResultsComponent
  ]
})
export class AdvancedSearchResearchResultsModule { }
