import { NgModule}            from '@angular/core';
import { CommonModule }        from '@angular/common';
import { FormsModule }         from '@angular/forms';

import{SearchOrganizationsComponent} from './searchOrganizations.component';

import {SearchResultsModule } from '../searchUtils/searchResults.module';

import {OrganizationsServiceModule} from '../../services/organizationsService.module';
import {SearchFormModule} from  '../searchUtils/searchForm.module';
import {SearchPageModule} from '../searchUtils/searchPage.module';
import {FreeGuard} from'../../login/freeGuard.guard';
import {IsRouteEnabled} from '../../error/isRouteEnabled.guard';

@NgModule({
  imports: [
    CommonModule, FormsModule,

    OrganizationsServiceModule,
     SearchFormModule, SearchResultsModule, SearchPageModule

  ],
  declarations: [
    SearchOrganizationsComponent
   ],
  providers:[FreeGuard, IsRouteEnabled],
  exports: [
    SearchOrganizationsComponent
     ]
})
export class SearchOrganizationsModule { }
