import { NgModule}            from '@angular/core';
import { CommonModule }        from '@angular/common';
import { FormsModule }         from '@angular/forms';

import{SearchProjectsComponent} from './searchProjects.component';

import {SearchResultsModule } from '../searchUtils/searchResults.module';

import {ProjectsServiceModule} from '../../services/projectsService.module';
import {SearchFormModule} from  '../searchUtils/searchForm.module';
//import {SearchFilterModalModule} from '../searchUtils/searchFilterModal.module';
import {SearchPageModule} from '../searchUtils/searchPage.module';
import {FreeGuard} from'../../login/freeGuard.guard';
import {IsRouteEnabled} from '../../error/isRouteEnabled.guard';

@NgModule({
  imports: [
    CommonModule, FormsModule,

    ProjectsServiceModule,
     SearchFormModule, SearchResultsModule,  SearchPageModule

  ],
  declarations: [
    SearchProjectsComponent
   ],
  providers:[FreeGuard, IsRouteEnabled],
  exports: [
    SearchProjectsComponent
     ]
})
export class SearchProjectsModule { }
