import { NgModule}            from '@angular/core';
import { CommonModule }        from '@angular/common';
import { FormsModule }         from '@angular/forms';

import {SearchResearchResultsComponent} from './searchResearchResults.component';
import {SearchResultsModule } from '../searchUtils/searchResults.module';
import {SearchResearchResultsServiceModule} from '../../services/searchResearchResultsService.module';
import {SearchFormModule} from  '../searchUtils/searchForm.module';
import {SearchPageModule} from '../searchUtils/searchPage.module';
import {FreeGuard} from'../../login/freeGuard.guard';
import {IsRouteEnabled} from '../../error/isRouteEnabled.guard';

@NgModule({
  imports: [
    CommonModule, FormsModule,
    SearchResearchResultsServiceModule,
    SearchFormModule, SearchResultsModule, SearchPageModule

  ],
  declarations: [
    SearchResearchResultsComponent
  ],
  providers:[FreeGuard, IsRouteEnabled],
  exports: [
    SearchResearchResultsComponent
  ]
})
export class SearchResearchResultsModule { }
