export class ResultLandingInfo {
  // PUBLICATION, DATASET, SOFTWARE, ORP
  record;

  // PUBLICATION, DATASET, SOFTWARE, ORP, DELETED_BY_INFERENCE
  title: string;
  accessMode: string;
  authors: {"fullName": string, "orcid": string}[];
  date: string;
  dateofacceptance: string;
  embargoEndDate: string;
  types: string[];
  identifiers: Map<string, string[]>;     //key is the classname
  languages: string[];
  countries: string[];
  description: string;

  hostedBy_collectedFrom: {"downloadName": string, "downloadUrl": string[],
    "collectedName": string, "collectedId": string,
    "accessMode": string[], "bestAccessMode": string,
    "type": string, "year":string}[];

  // PUBLICATION, DATASET, SOFTWARE, ORP
  fundedByProjects: { "id": string, "acronym": string, "title": string,
    "funderShortname": string, "funderName": string,
    "funding": string, "code": string, "provenanceAction": string, "inline": boolean}[];

  underCurationMessage: boolean;
  publisher: string;
  journal: {"journal": string, "issn": string, "lissn": string, "eissn": string,
    "issue": string, "volume": string, "start_page": string, "end_page": string};

  subjects: string[];
  otherSubjects: Map<string, string[]>;
  classifiedSubjects: Map<string, string[]>;          //<class of subject, subjects>

  // percentage is for trust
  relatedResearchResults: Map<string, { "name": string, "id": string, "date": string, "percentage": number, "class": string}[]>;
  // percentage is for similarity
  similarResearchResults: { "name": string, "id": string, "date": string, "percentage": number, "class": string}[];
  //isSupplementedBy
  supplementaryResearchResults;
  //isSupplementTo
  supplementedByResearchResults;

  contexts: { "labelContext": string, "labelCategory": string, "labelConcept": string, "inline": boolean}[];

  deletedByInferenceIds: string[];

  // PUBLICATION, DATASET, ORP
  references: { "name": string, "url": string}[];

  // PUBLICATION
  bioentities: Map<string, Map<string, string>>;      //<site name, <>>
  software: { "name": string, "url": string}[];      //<site name, <>>
  organizations: {"name": string, "shortname":string, "id": string, "websiteUrl": string, "country": string, "trust": number}[];
  openCitations: {"url": string, "title": string, "year": string, "doi": string, "authors": string[]}[];

  // DATASET
  subtitle: string;

  // SOFTWARE
  programmingLanguages: string[];
}
